import { select } from 'd3';
//select('body').text('Hello D3 version 6'); 

//atan2(y2 - y1, x2 - x1) * 180 / PI;

const getTheta = (p1,p2) => { return Math.abs(Math.atan((p2[1]-p1[1])/(p2[0]-p1[0]))) }

const nd = ['Carbonated soft drinks ',
 'Fruit juices ',
 'Flavoured milk/milkshakes ',
 'Ready to drink coffee ',
 ' Buttermilk/chaas/lassi ',
 'Iced Tea',
 'Energy Drinks ']

const ni = ['While hanging around people',
 'While returning from some activity',
 'Alone',
 'Before doing some activity']

const nAll = [...nd,...ni]

const rx = 330
const ry = 250
const r = 150

d3.select('#outline')
  .attr('cx',rx)
  .attr('cy',ry)
  .attr('r',r)

d3.select('svg').select('g').append('circle').attr('cx',rx).attr('cy',ry).attr('r','2')


const sized = [31.757673195170206,
 12.609290063580957,
 26.513867106490384,
 53.37849038860681,
 12.275860767937282,
 33.991957588348285,
 12.693896120040934]

const font = d3.scaleLinear().domain([0,d3.max(sized)]).range([0.03,0.09])

const displacement = d3.scaleLinear().domain([0,30]).range([0,60])

const xd = [-0.5049334802653964,
 -0.4379899648120784,
 0.5124108004834792,
 0.504942724857818,
 0.18954241147591186,
 -0.4908124727923257,
 0.4075794517325714]

const yd = [-0.0872184499576443,
 -0.2659504995856446,
 -0.00022148096889750533,
 -0.08716491334878664,
 0.47606570109369956,
 0.1472005232919441,
 0.3105541305977366]

const xi = [-0.30045893315660643,
 0.1401235975378976,
 -0.0942431848103725,
 0.3327031164246965]

const yi = [0.010697186310019324,
 0.1680009353619136,
 -0.057862287952148275,
 -0.07748636935000737]


 const pd = xd.map((x,i) =>{ return [x,yd[i]] })
 
 const pi = xi.map((x,i)=>{ return [x,yi[i]]})
 
 const angles_d = pd.map( p => getTheta(p,[0,0]) )

// x = r * cos + cx
// y = r * sin + cy   
 const getCircleTransform = (theta,r,cx,cy,pd) =>
           { 
             console.log(pd,theta*(180/Math.PI))
             
             if(pd[0] > 0 && pd[1] > 0)
             return [r*Math.cos(theta) + cx,  -r*Math.sin(theta) + cy ,-theta*(180/Math.PI) ]; 
             else if(pd[0] < 0 && pd[1] < 0)
             return [r*Math.cos(Math.PI + theta) + cx,  -r*Math.sin(Math.PI + theta) + cy,-theta*(180/Math.PI) ]; 
             else if(pd[0] > 0 && pd[1] < 0)
             return [r*Math.cos(-theta) + cx, -r*Math.sin(-theta) + cy ,theta*(180/Math.PI) ]; 
             else if(pd[0] < 0 && pd[1] > 0)
             return [r*Math.cos(Math.PI - theta) + cx, -r*Math.sin(Math.PI - theta) + cy,theta*(180/Math.PI) ]; 
           }
 
 const newPos_d = angles_d.map((x,i) => getCircleTransform(x,r,rx,ry,pd[i]) )
 
 
const max_i = 0.5124108483491929
 
// nr =  (d/max_i)*r 
//d = (Math.sqrt(Math.pow(x[0],2) + Math.pow(x[1],2))/max_i ) * r

const pi_r =pi.map(x =>(Math.sqrt(Math.pow(x[0],2) + Math.pow(x[1],2))/max_i ) * r  )

const pd_old =  xd.map((x,i) =>{ return [x,yd[i]] })


const angles_i = pi.map( p => getTheta(p,[0,0]) )

console.log('ang',angles_i)

const newPos_i = angles_i.map((x,i) => getCircleTransform(x,pi_r[i],rx,ry,pi[i]) )

console.log('i',newPos_i)

const all_pos = [...newPos_d,...newPos_i,]

const textJoin = d3.select('svg').select('g').selectAll('text').data(all_pos,(d,i)=>nAll[i])

textJoin.enter().append('text')
   .text((d,i)=>nAll[i])
   .merge(textJoin)
   .attr('id',(d,i)=>nAll[i])
   .attr('x',(d,i) => { 
        
        if(d[0]<=rx && nd.includes(nAll[i])){
          
        console.log('Occupation',nAll[i].length,nAll[i].length*font(sized[i]))
        return d[0]+displacement(nAll[i].length); 
        }
        else if(d[0]>rx && nd.includes(nAll[i])) {
          
        console.log('Occupation',nAll[i].length,nAll[i].length*font(sized[i]))
        return d[0]
        }
        else
        return d[0];  
    } )
   .attr('y',d => d[1])
   .style('font-size',(d,i)=>{
         if(nd.includes(nAll[i])) 
         return  font(sized[i]) +'em'
         else return '0.046em'  
       })
   .style('opacity',(d,i)=>{
         if(nd.includes(nAll[i])) 
         return '0.8'
         else return '1'        
      })
    .style('fill',(d,i)=>{
         if(nd.includes(nAll[i])) 
         return '#000000'
         else return '#000000'        
       })
    .style('font-family','Lato,Arial, Helvetica, sans-serif')
  .attr('dx',(d,i) => { 
        if(d[0]<=rx && nd.includes(nAll[i]))
        return '-2em';  
    } )
  .attr('text-anchor',(d,i)=>{
     if(d[0]<=rx && nd.includes(nAll[i])){
        	return 'end'; 
        }
        else if(d[0]>rx && nd.includes(nAll[i])) {
        	return 'start'; 
        }
        else
        return 'middle'; 

  })
  .attr('transform',(d,i) =>{ if(nd.includes(nAll[i]))return  `rotate(${d[2]},${d[0]},${d[1]})`;})
  .each(function(d,i){ 
  
      if(!nd.includes(nAll[i])){
           d3.select('svg').select('g')
                           .append('circle')
                           .attr('cx',d[0])
                           .attr('cy',d[1])
                           .attr('r','3')
                           .style('fill','black')
                           .style('opacity',0.4)
      } 
 })
 
 


